#!/usr/bin/python

## thread where dd runs in a loop
## 25 times a second
## on each loop it checks the variable for start position


import threading, subprocess, time, os, signal, string
import serial

#ddThread = None
#arduinoThread = None

locations=['/dev/ttyUSB0','/dev/ttyUSB1','/dev/ttyUSB2','/dev/ttyUSB3']
disks=['/dev/sdb','/dev/sdc','/dev/sdd','/dev/sde','/dev/sdf','/dev/sdg']
fifo='/tmp/dataj-fifo'

for device in locations:
	try:
		arduino = serial.Serial(device, 9600)
	except:
		print "Failed to connect on",device
	
#arduino = serial.Serial('/dev/ttyUSB0', 9600)

class Arduino(threading.Thread):
	def __init__(self):
		threading.Thread.__init__(self)
		self.kill = False
		self.num = 0
		global ddThread
	def run(self):
		print 'reading arduino'
		while not self.kill:
			try:
				n = arduino.read()
			except:
				time.sleep(2)
				n = '1'
			if n == '1':
				if ddThread.start_pos >= 0:
					ddThread.start_pos += 1
			if n == '0':
				if ddThread.start_pos > 0:
					ddThread.start_pos -= 1
				else:
					## this gets set only once when we are at the beginning
					## of disk (start_pos = 0) and user scrolls back. 
					ddThread.start_pos = ddThread.size - 1

class RunDd(threading.Thread):
	def __init__(self):
		threading.Thread.__init__(self)
		self.start_pos = 0 ## initial start position
		self.kill = False
		self.disk = ''
		self.size = 0
	def run(self):
		print 'running dd'
		while len(self.disk) < 1:
			for disk in disks:
				if os.access(disk, os.R_OK):
					try:
						self.disk = disk
						print 'using ' + self.disk
						size = subprocess.Popen(['/sbin/fdisk','-l',self.disk],stdout=subprocess.PIPE).communicate()
						self.size = int(string.split(size[0][:60])[4])/460800
						print 'size: ' + str(self.size)
						self.start_pos = 0
					except:
						print 'problem detecting disk size'
			print 'waiting for disk...'
			time.sleep(1)

		while not self.kill:
			if self.start_pos >= self.size-1:
				self.start_pos = 0
#				arduinoThread.num = 0
				print 'looping...'

			disk = 'if=' + self.disk
			self.fifo = 'of=' + fifo
			skip = 'skip=' + str(self.start_pos)
			subprocess.Popen(['dd',disk,self.fifo,'bs=460800','count=1', 'status=noxfer', skip],stderr=subprocess.PIPE,stdout=subprocess.PIPE).wait()
#			print str(self.start_pos)
		os.system('killall -9 dd')
		print 'dd got killed!'
		self.start_pos = 0
		arduinoThread.num = 0
class RunGst(threading.Thread):
	def __init__(self):
		threading.Thread.__init__(self)
	def run(self):
		print 'running gst'
		self.cmd = 'gst-launch-0.10 filesrc location=' + fifo + ' ! queue ! tee name=v ! queue max-size-bytes=0 ! videoparse framerate=1 ! videoscale ! video/x-raw-yuv, width=40, height=30 ! videorate ! audioparse ! audiorate ! autoaudiosink v. ! queue leaky=2 ! videoparse width=640 height=480 framerate=1 ! videorate ! xvimagesink sync=false'
#		self.cmd = 'gst-launch-0.10 filesrc location=' + fifo + ' ! queue ! audioparse rate=44100 channels=1 ! audiorate ! audioconvert ! autoaudiosink'
		self.gst = subprocess.Popen(self.cmd.split())
		self.gst.communicate()
	def kill(self):
		try:
			os.kill(self.gst.pid, signal.SIGKILL)
	#		self.gst.kill
			os.system('killall -9 gst-launch-0.10') 
			print 'gst got killed!'
		except:
			print 'problem killing gst'

## dd thread
def rundd():
	dd = RunDd()
	dd.start()
	return dd

## gst thread
def rungst():
	gst = RunGst()
	gst.start()
	return gst

## arduino thread
def readarduino():
	arduino = Arduino()
	arduino.start()
	return arduino

## run arduino thread
arduinoThread = readarduino()
ddThread = RunDd()
gstThread = RunGst()

## main control loop
while arduinoThread.isAlive():
	_last = ddThread.start_pos
	_timer = time.time()

	while ddThread.start_pos == _last and ddThread.isAlive():
		if time.time() > _timer+10.0:
#			print 'killing dd...'
			ddThread.kill = True
			if gstThread.isAlive():
				gstThread.kill()
			break
		time.sleep(1)

	while not ddThread.isAlive():
		if ddThread.start_pos != _last:
#			print 'running dd!'
			## run arduino thread here!
			ddThread = rundd()
			gstThread = rungst()
		time.sleep(0.1)

	time.sleep(1)



